#ifndef _ADC_C_
#define _ADC_C_


#include "adc-lib.h"


typedef union
{
	uint16_t word;
	uint8_t byte[2];
} two_byte_union;



//przerwanie ADC
ISR(ADC_vect)
{
/*
	Kod przerwania ADC
	Uwagi:
	- odczytywac rejestry ADCL nastepnie ADCH 
*/
	adcres = ADCL;
	adcres = ADCH;

	ADC_flags |= _BV(ADCFINE);
}

uint8_t ADC_8bit(uint16_t resadc)
{
two_byte_union convers;

	convers.word = resadc;

	return convers.byte[0];

}


void ADC_config(void)
{
  ADCSRA |= _BV(ADEN);

 // Przesunicie MSB w lewo (zczytywanie z ADCH - 8 bit)
 #if LEFT_ADJUST_RESULT
 	ADMUX |= _BV(ADLAR);
 #else
 	ADMUX &= ~_BV(ADLAR);
 #endif /* LEFT_ADJUST_RESULT */

 
 //wybor zrodla odniesienia
 #if AREF_SOURCE
	ADMUX &=~_BV(REFS1);
	ADMUX &=~_BV(REFS0);
 #endif /* AREF_SOURCE */
 #if AVCC_SOURCE
	ADMUX |= _BV(REFS1);
	ADMUX &=~_BV(REFS0);
 #endif /* AVCC_SOURCE */
 #if INTERNAL
	ADMUX |= _BV(REFS1);
	ADMUX |= _BV(REFS0);
 #endif /* INTERNAL */



 #if PRESCALER_2			//001
	ADCSRA |=  _BV(ADPS0);
	ADCSRA &= ~_BV(ADPS1);
	ADCSRA &= ~_BV(ADPS2);	 	
 #endif /* PRESCALER_2 */
 #if PRESCALER_4			//010
	ADCSRA &= ~_BV(ADPS0);
	ADCSRA |=  _BV(ADPS1);
	ADCSRA &= ~_BV(ADPS2);	 	
 #endif /* PRESCALER_4 */
 #if PRESCALER_8			//011
	ADCSRA |=  _BV(ADPS0);
	ADCSRA |=  _BV(ADPS1);
	ADCSRA &= ~_BV(ADPS2);	 	
 #endif /* PRESCALER_8 */
 #if PRESCALER_16			//100
	ADCSRA &= ~_BV(ADPS0);
	ADCSRA &= ~_BV(ADPS1);
	ADCSRA |=  _BV(ADPS2);	 	
 #endif /* PRESCALER_16 */
 #if PRESCALER_32			//101
	ADCSRA |=  _BV(ADPS0);
	ADCSRA &= ~_BV(ADPS1);
	ADCSRA |=  _BV(ADPS2);	 	
 #endif /* PRESCALER_32 */
 #if PRESCALER_64			//110
	ADCSRA &= ~_BV(ADPS0);
	ADCSRA |=  _BV(ADPS1);
	ADCSRA |=  _BV(ADPS2);	 	
 #endif /* PRESCALER_64 */
 #if PRESCALER_128			//111
	ADCSRA |=  _BV(ADPS0);
	ADCSRA |=  _BV(ADPS1);
	ADCSRA |=  _BV(ADPS2);	 	
 #endif /* PRESCALER_128 */




 #if FRE_RUNNING_MODE
	ADCSRA |= _BV(ADFR);
 #else
	ADCSRA &= ~_BV(ADFR);
 #endif /*FRE_RUNNING_MODE */


 // aktywacja przerwania
 ADCSRA |= _BV(ADIE);

} /* ADC_config */



void ADC_start(uint8_t we)
{
 //wybor wejscia ADC;
 ADMUX &= 0xF0;				//wyzerowanie MUXx
 //ADMUX |= we & _BV(MUX3);
 //ADMUX |= we & _BV(MUX2);
 //ADMUX |= we & _BV(MUX1);
 //ADMUX |= we & _BV(MUX0);
 ADMUX |= (we & 0x0F);
 
 ADCX_IN_CONFIG(we);

 //uruchomienie konwersji
 ADCSRA |= _BV(ADSC);

} /* ADC_start */


void ADC_fstart(void)
{
 //szybkie uruchomienie konwersji
 ADCSRA |= _BV(ADSC);

} /* ADC_fstart */


void	ADC_startV(uint8_t min, uint8_t max, uint8_t *vect)
{
volatile static uint8_t num;
	
	ADC_flags &= ~_BV(VECTDONE);
	
	
	if(ADC_flags & _BV(ADCFINE))
	{
		ADC_flags &= ~_BV(ADCFINE);
		vect[num] = adcres;
		++num;
		if(num <= max-min)
			ADC_start(num+min);
	}

	if (num > max-min)
	{
		ADC_flags |= _BV(VECTDONE);
		num=0;
	}
}


#endif
