/*
	plik z nazwami rejestrow przystosowanymi do ATmega8
*/

#ifndef _ADC_H_
#define _ADC_H_

#include <avr/interrupt.h>
#include "../config.h"


// wybor zrodla odniesienia
#define AREF_SOURCE		1
#define AVCC_SOURCE		0
#define INTERNAL		0

#define LEFT_ADJUST_RESULT	1

#define	FRE_RUNNING_MODE	0

//Maximum resolution between 50kHz - 200kHz
#define PRESCALER_2		0
#define PRESCALER_4		0
#define PRESCALER_8		0
#define PRESCALER_16	0
#define PRESCALER_32	0
#define PRESCALER_64	1
#define PRESCALER_128	0

//Input chanel (for ADC_start)
#define ADC_0	0x00
#define ADC_1	0x01
#define ADC_2	0x02
#define ADC_3	0x03
#define ADC_4	0x04
#define ADC_5	0x05
#define ADC_123	0x0E
#define ADC_GND	0x0F


#define ADCX_IN_CONFIG(PIN)		\
		DDRC  &= ~_BV(PIN);		\
		PORTC &= ~_BV(PIN)

void    ADC_config(void);
void    ADC_start(uint8_t we);
void    ADC_fstart(void);
uint8_t ADC_8bit(uint16_t resadc);
void	ADC_startV(uint8_t min, uint8_t max, uint8_t *vect);




#endif
